/*
 *	CreateMainWindow()	-	creates main window for xshowcgm
 *
 *	RCS:
 *		$Revision$
 *		$Date$
 *
 *	Security:
 *		Unclassified
 *
 *	Description:
 *		text
 *
 *	Input Parameters:
 *		type	identifier	description
 *
 *		text
 *
 *	Output Parameters:
 *		type	identifier	description
 *
 *		text
 *
 *	Return Values:
 *		value	description
 *
 *	Side Effects:
 *		text
 *
 *	Limitations and Comments:
 *		text
 *
 *	Development History:
 *		when	who					why
 *	10/29/94	muquit@semcor.com	first cut
 */

#include "xhead.h"
#include "xsf.h"
#include "defines.h"
#include "menus.h"

Widget CreateMainWindow (parent)
Widget
	parent;
{
	Arg
		args[20];

	int
		n;

	static Widget
		mainwW,
		formW,
		scrollW,
		textframeW,
		textformW,
		fontTextW,
		searchframeW,
		searchRCW,
		fontLabelW,
		fontListW,
		menubarW;

	static Widget
		searchtextW,
		drawingaW;

	Widget	
		vsbW;

	int
		i;

	Pixel
		bg_pixel;

	static PushMenu filemenu[] =
	{
		
		/*{ "Open Rolodex File ...", 'O', FileMenuCB, (XtPointer)FILE_OPEN },*/
		{ "Quit", 'Q', FileMenuCB, (XtPointer) QUIT }
	};

	/*
	** create main window
	*/

	mainwW = XtVaCreateWidget ("MainW",
		xmMainWindowWidgetClass, parent,
		NULL);
	
    GmainwW=mainwW;
	/*
	** create menubar
	*/

	menubarW = XmCreateMenuBar (mainwW, "Menubar",
		NULL, 0);
	(void) CreateMenuPane (menubarW, "File",
		filemenu, XtNumber (filemenu));
	
	/*
	** create the base form
	*/
	
	formW = XtVaCreateWidget ("Form",
		xmFormWidgetClass, mainwW,
		NULL);

	/*
	** create a frame for the text widget.  I am writing this program mainly
	** because of this, so I can copy the font from the widget
	*/

	textframeW = XtVaCreateWidget ("Tframe",
		xmFrameWidgetClass, formW,
		/*
		XmNshadowType, XmSHADOW_ETCHED_OUT,
		*/
		XmNshadowThickness, 0,
		XmNtopAttachment,  XmATTACH_FORM,
		XmNleftAttachment,  XmATTACH_FORM,
		XmNleftOffset, 2,
		XmNrightAttachment,  XmATTACH_FORM,
		XmNrightOffset, 2,
		NULL);
	/*
	** create a form on the frame
	*/
	textformW = XtVaCreateWidget("Tform",
		xmFormWidgetClass, textframeW,
		NULL);

	/*
	** create the text widget
	*/
	fontTextW = XtVaCreateWidget ("Fontext",
		xmTextFieldWidgetClass, textformW,
		XmNtopAttachment, XmATTACH_FORM,
		XmNleftAttachment, XmATTACH_FORM,
		XmNrightAttachment, XmATTACH_FORM,
		XmNbottomAttachment, XmATTACH_FORM,
		NULL);

	GfontTextW= fontTextW;

    /*
    ** create a frame for holding the font label
    */

    searchframeW = XtVaCreateWidget ("MframeW",
        xmFrameWidgetClass, formW,
        XmNshadowType, XmSHADOW_ETCHED_OUT,
        XmNshadowThickness, 5,
        XmNleftAttachment,  XmATTACH_FORM,
        XmNrightAttachment,  XmATTACH_FORM,
        XmNbottomAttachment, XmATTACH_FORM,
        NULL);

	/*
	** create the fontLabelW
	*/
	fontLabelW = XtVaCreateManagedWidget("Fontlabel",
		xmLabelWidgetClass, searchframeW,
		NULL);
	GfontLabW= fontLabelW;
    XtVaGetValues(fontLabelW,
        XmNfontList, &Gfontlist,
        NULL);
	/*
	** create the list
	*/

	n = 0;
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET); n++;
	XtSetArg(args[n], XmNtopWidget, textframeW); n++;
    XtSetArg(args[n], XmNbottomAttachment, XmATTACH_WIDGET); n++;
	XtSetArg(args[n], XmNbottomWidget,  searchframeW); n++;
    XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM); n++;
    XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n++;
    XtSetArg(args[n], XmNtopOffset, (int)2); n++;
    XtSetArg(args[n], XmNbottomOffset, (int)2); n++;
    XtSetArg(args[n], XmNleftOffset, (int)2); n++;
    XtSetArg(args[n], XmNrightOffset, (int)2); n++;
    XtSetArg(args[n], XmNscrollBarDisplayPolicy, XmSTATIC); n++;
    XtSetArg(args[n], XmNselectionPolicy, XmBROWSE_SELECT); n++;
	XtSetArg(args[n], XmNlistMarginWidth, 2);n++;
	XtSetArg(args[n], XmNlistMarginHeight, 2);n++;
	XtSetArg(args[n], XmNlistSpacing, 7); n++;

    fontListW = XmCreateScrolledList(formW,"fontlist",
		args, n);

	XtManageChild (fontListW);

	GfontListW=fontListW;


/*	XtAddCallback (fontListW, XmNsingleSelectionCallback,
		SelectCB, NULL);*/
	XtAddCallback (fontListW, XmNbrowseSelectionCallback,
		(XtCallbackProc) SelectCB, NULL);


	XtVaGetValues (XtParent(fontListW),
		XmNverticalScrollBar, &vsbW,
		NULL);

	bg_pixel = (Pixel) AllocateNamedColor(Gdisplay, GscbBgcolor);

	if (bg_pixel > 256)	/* parse error */
	{
		/*
		** choose the color of the toplevel widget
		*/

		XtVaGetValues (GmainwW,
			XmNbackground, &bg_pixel,
			NULL);
	}

	SetScrollbarColors(vsbW, (Widget) NULL, bg_pixel);

	XtManageChild (searchframeW);
	XtManageChild (fontTextW);
	XtManageChild (textformW);
	XtManageChild (textframeW);
	XtManageChild (formW);
	XtManageChild (menubarW);
	XtManageChild (mainwW);
}
