/*
 *	CreateMenuPane()	- creates menu panes
 *
 *	RCS:
 *		$Revision$
 *		$Date$
 *
 *	Security:
 *		Unclassified
 *
 *	Description:
 *		text
 *
 *	Input Parameters:
 *		type	identifier	description
 *
 *		text
 *
 *	Output Parameters:
 *		type	identifier	description
 *
 *		text
 *
 *	Return Values:
 *		value	description
 *
 *	Side Effects:
 *		text
 *
 *	Limitations and Comments:
 *		text
 *
 *	Development History:
 *		when	who					why
 *	10/29/94	muquit@semcor.com	first cut
 */

#include "xhead.h"
#include "xsf.h"
#include "defines.h"
#include "menus.h"

WidgetList CreateMenuPane (menubarW, name, menulist, nitems)
Widget
	menubarW;
char
	*name;
PushMenu
	*menulist;
Cardinal
	nitems;
{
	register int
		i,
		n;

	Arg
		args[2];

	WidgetList
		buttons;

	/*
	** allocate memory for widgetlist to hold all button widgets
	*/

#ifdef DEBUG
	(void) fprintf (stderr, 
		" menu name: %s\n", name);
	(void) fprintf (stderr,
		" nitems: %d\n", nitems);
#endif

	buttons = (WidgetList)XtMalloc((nitems+2) * sizeof(Widget));
	buttons[nitems+1] = XmCreatePulldownMenu(menubarW, name,
		NULL, 0);

	for (i=0; i < nitems; i++)
	{
		if ((strcmp(menulist[i].name, "separator") == 0) &&
			(menulist[i].func == NULL)) 
		{
			buttons[i] = XtVaCreateWidget (menulist[i].name,
				xmSeparatorWidgetClass, buttons[nitems+1],
				NULL);
		}
		else
		{

			buttons[i] = XtVaCreateWidget (menulist[i].name,
				xmPushButtonWidgetClass, buttons[nitems+1],
				XmNmnemonic, menulist[i].mnemonic,
				NULL);

			if (menulist[i].func)
				XtAddCallback(buttons[i], XmNactivateCallback,
					menulist[i].func, menulist[i].data);
		}
	}
	XtManageChildren(buttons, nitems);
	n = 0;
	XtSetArg (args[n], XmNmnemonic, name[0]);				n++;
	XtSetArg (args[n], XmNsubMenuId, buttons[nitems+1]);	n++;
	buttons[nitems] = XtVaCreateManagedWidget (name,
		xmCascadeButtonWidgetClass, menubarW, 
		XmNmnemonic, name[0],
		XmNsubMenuId, buttons[nitems+1],
		NULL);

	return (buttons);
}
