#ifndef DEFINES_H
#define DEFINES_H
/*
** some important clinet_data
*/


#define CGM_WIDTH 1024
#define CGM_HEIGHT 1024

#define ROLODEX_MAGICK		"-YAMROLODEX-"

#define GAMMA_CORRECT       1
#define HISTOGRAM_EQUALIZE  2
#define HISTOGRAM_NORMALIZE 3
#define CONVERT_TO_GRAY     4
#define CONVERT_TO_MONO     5
#define NEGATE_IMAGE        6
#define REDUCE_COLORS       7
#define EMBOSS_IMAGE        8
#define SMOOTH_IMAGE        9
#define EDGE_IMAGE          10
#define BRIGHTEN_IMAGE      11
#define DARKEN_IMAGE        12
#define OILPAINT_IMAGE      13
#define MAGNIFY_IMAGE		14
#define FLIP_IMAGE			15
#define FLOP_IMAGE			16
#define	ROTATE_90RIGHT		17
#define ROTATE_90LEFT		18
#define CROP_IMAGE			19
#define EDIT_COLORMAP		20
#define CONVERT_24TO8		21

#define FILE_OPEN				1
#define FILE_SAVE				2
#define QUIT					3

#define IncludePreviewBitmap    1
#define NoPreviewBitmap         2
#define COMPRESSION             100
#define PREVIEW_BITMAP          101
#define PAPER_SIZE              102

#define FILE_EXISTS			600
#define FILE_IS_A_DIRECTORY 700
#define FILE_IS_UNREADABLE  800

#define YES	1
#define NO	2

#define TRUE    1
#define FALSE   0

/*
** define various file formats
*/

#define GIF_FORMAT      1
#define TIFF_FORMAT     2
#define PS_FORMAT       3
#define EPS_FORMAT      4
#define TARGA_FORMAT    5
#define SUN_FORMAT      6
#define XWD_FORMAT      7
#define JPEG_FORMAT		8

/*
** from ImageMagick
*/

#define SuspendTime  40

#define UndefinedColormap   0
#define PrivateColormap     1
#define SharedColormap      2

#define EVEN(x) (((x) & 1) == 0)
#define PI 3.14159265358979323846

#define DownShift(x) ((int) ((x)+(1L << 15)) >> 16)
#define False  0
#define Max(x,y)  (((x) > (y)) ? (x) : (y))
#define Min(x,y)  (((x) < (y)) ? (x) : (y))
#define MinInfoSize (1 << 18)
#define True  1
#define UpShift(x) ((x) << 16)
#define UpShifted(x) ((int) ((x)*(1L << 16)+0.5))
#define AbsoluteValue(x)  ((x) < 0 ? -(x) : (x))
#define DegreesToRadians(x) ((x)*3.14159265358979323846/180.0)

#define Intensity(color)  (unsigned int)  \
  ((unsigned int) ((color).red*77+(color).green*150+(color).blue*29) >> 8)

#define XStandardPixel(map,color,dx)  (unsigned long) (map->base_pixel+  \
  ((color.red*map->red_max+(1 << (dx-1)))/((1 << dx)-1))*map->red_mult+  \
  ((color.green*map->green_max+(1 << (dx-1)))/((1 << dx)-1))*map->green_mult+ \
  ((color.blue*map->blue_max+(1 << (dx-1)))/((1 << dx)-1))*map->blue_mult)

#define MaxColormapSize		65535
#define MaxImageSize		(4096*4096)
#define MaxRGB				255
#define MaxRunlength		255
#define MaxTextLength		2048

#define UndefinedId			0
#define ImageMagickId		1

#define UndefinedClass		0
#define DirectClass			1
#define PseudoClass			2

#define UndefinedColorspace	0
#define RGBColorspace		1
#define GRAYColorspace		2
#define XYZColorspace		3
#define YCbCrColorspace		4
#define YIQColorspace		5
#define YUVColorspace		6
#define OHTAColorspace		7

#define UndefinedCompression			0
#define NoCompression					1
#define RunlengthEncodedCompression		2
#define QEncodedCompression				3
#define LZWCompression					4
#define PACKBITSCompression				5

#define UndefinedInterlace				0
#define NoneInterlace					1
#define LineInterlace					2
#define PlaneInterlace					3

#define UndefinedCompositeOp			0
#define OverCompositeOp					1
#define InCompositeOp					2
#define OutCompositeOp					3
#define AtopCompositeOp					4
#define XorCompositeOp					5
#define PlusCompositeOp					6
#define MinusCompositeOp				7
#define AddCompositeOp					8
#define SubtractCompositeOp				9
#define DifferenceCompositeOp			10
#define ReplaceCompositeOp				11

#define PSDensityGeometry				"72x72"
#define PSPageGeometry					"612x792+18+94"
#define TextPageGeometry				"612x792+36+36"

#endif /*DEFINES_H*/
