/*
 *	Load_Font()	-	Loads the requested font in the display
 *
 *	RCS:
 *		$Revision$
 *		$Date$
 *
 *	Security:
 *		Unclassified
 *
 *	Description:
 *		This function loads the specified font in the display. The font must
 *		be set to the GC to get the effect. If a bad fontname is specified
 *		"fixed" font will be used. If no font is specified, "variable" is 
 *		used to draw the labels
 *
 *	Input Parameters:
 *		type	identifier	description
 *
 *		text
 *
 *	Output Parameters:
 *		type	identifier	description
 *
 *		text
 *
 *	Return Values:
 *		value	description
 *
 *	Side Effects:
 *		text
 *
 *	Limitations and Comments:
 *		text
 *
 *	Development History:
 *		when	who		why
 *	9/20/93, mm,	first cut
 *	04/01/94	mm	modified struct, now returns XFontStruct
 */

#include "xhead.h"
#include "xsf.h"

XFontStruct *LoadFont (disp, font_name)		
Display
	*disp;
char
	*font_name;
{

	XFontStruct		*font;

	font = XLoadQueryFont (disp, font_name);

	if (font == (XFontStruct *) NULL)
	{
		fprintf (stderr, "Could not load font \"%s\"\n", font_name);
		fprintf (stderr, "Using \"fixed\" font.\n");
		font = XLoadQueryFont (disp, "fixed");
	}

	return (font);
}
