/*
 *	main.c	- main module for xshowcgm
 *
 *	RCS:
 *		$Revision$
 *		$Date$
 *
 *	Security:
 *		Unclassified
 *
 *	Description:
 *		This file contains the main GUI building routine for xshowcgm.
 *
 *	Input Parameters:
 *		type	identifier	description
 *
 *		int	argc;
 *		char **argv;
 *
 *	Output Parameters:
 *		type	identifier	description
 *
 *		None
 *
 *	Return Values:
 *		value	description
 *		none
 *
 *	Side Effects:
 *		None
 *
 *	Limitations and Comments:
 *		needs Motif and X library to compile
 *
 *	Development History:
 *		when	who		why
 *	10/28/94	muquit	first cut
 */

#include "xhead.h"
#include "defines.h"


#define MAIN
#include "xsf.h"
#include "menus.h"

#ifdef HasEditres
#include <X11/Xmu/Editres.h>
#endif

typedef struct
{
	String
		ScrollbarBg;
} YAppResources, *YAppResourcesP;

#define YOffset(x) XtOffset(YAppResourcesP, x)

static XtResource resources[] =
{

	{"ScrollbarBg", "ScrollbarBg", XtRString, sizeof(String),
		YOffset(ScrollbarBg), XtRString, "Red"},
};

/*
** define fallback resources
*/

static char *app_defaults[] =
{
#include "Mxshowfont.ad.h"
	NULL
};

main (argc, argv)
int
	argc;
char
	**argv;
{
	int
		screen;

	XtAppContext
		app;
	
	register int
		i,
		j,
		n;

	Arg
		args[20];

/*
** Initalize Globals ---Starts---
*/

	Gdisplay = (Display *) NULL;
    Ggc=(GC) NULL;
    GfontListW=(Widget) NULL;
    GfontLabW=(Widget) NULL;
    GfontTextW=(Widget) NULL;
    Gfontlist=(XmFontList) NULL;

/*
** Initalize Globals ---Ends---
*/

	/*
	** create toplevel widget
	*/

	GtoplevelW= XtVaAppInitialize (&app, "MXshowfont",
		NULL, 0, &argc, argv, app_defaults, NULL);
	
	XtVaSetValues (GtoplevelW, 
		XmNallowShellResize, True,
		NULL);
	SetResources(GtoplevelW);
	/*
	** get the global Display
	*/
	Gdisplay = XtDisplay(GtoplevelW);
	screen = DefaultScreen (Gdisplay);
	Ggc = DefaultGC (Gdisplay, screen);
	GblackPixel = BlackPixel(Gdisplay, screen);
	GwhitePixel = WhitePixel (Gdisplay, screen);

/*
** add editres support
*/
#ifdef HasEditres
	XtAddEventHandler(GtoplevelW,
		(EventMask) 0, True, _XEditResCheckMessages, NULL);
#endif

	/*
	** create main window Widget
	*/
	(void) CreateMainWindow (GtoplevelW);
	XtRealizeWidget (GtoplevelW);


	XSetErrorHandler (XError);

	/*
	** go to event handling loop
	*/
	MakeFontList();
	XtAppMainLoop (app);
}

void SetResources(widget)
Widget
	widget;
{
	YAppResources
		appResources;
	
	XtGetApplicationResources(widget, (XtPointer) &appResources,
		resources, XtNumber(resources), NULL, 0);
	GscbBgcolor = mystrdup(appResources.ScrollbarBg);
}

