/*
 *	MakeFontList()	-	makes the fontfontlist 
 *
 *	RCS:
 *		$Revision$
 *		$Date$
 *
 *	Security:
 *		Unclassified
 *
 *	Description:
 *		text
 *
 *	Input Parameters:
 *		type	identifier	description
 *
 *		text
 *
 *	Output Parameters:
 *		type	identifier	description
 *
 *		text
 *
 *	Return Values:
 *		value	description
 *
 *	Side Effects:
 *		text
 *
 *	Limitations and Comments:
 *		text
 *
 *	Development History:
 *		who					when		why
 *		muquit@semcor.com	22-Nov-94	first cut
 */

#ifndef lint
static char rcsid[] = "$Id$";
#endif

#include "xhead.h"
#include "xsf.h"

void MakeFontList()
{
	char
		**fontlist,
		**listhead;
	
	XmString
		*xmtable;

	int
		i,
		j;

 	fontlist = XListFonts(Gdisplay,"*", 32767, &j);

	xmtable = (XmString *) calloc(j,sizeof(XmString));

	listhead = fontlist;
	fontlist = (char **) malloc(j*sizeof(char **));

	if (fontlist == (char **) NULL)
	{
		Warning("Memory Allocation Failed:", "MakeFontList()");
		return;
	}

	for (i=0; i < j; i++)
		fontlist[i] = listhead[i];

	(void) qsort ((void *) fontlist, j, sizeof(char **),
		(int (*) _D((const void *, const void *))) FontCompare);

	for(i=0; i < j; i++)
	{
		xmtable[i] = XmStringCreateSimple(fontlist[i]);
	}

	XtUnmapWidget (GfontListW);
	XmListDeleteAllItems(GfontListW);
	XmListAddItems(GfontListW, xmtable, j, 0);
	XtMapWidget(GfontListW);

	for (i=0; i < j; i++)
		XmStringFree (xmtable[i]);

	free (xmtable);

	XFreeFontNames (fontlist);
	(void) free ((char *) fontlist);
}
