/*
 *	SelectCB()	- select callback routine for the list
 *
 *	RCS:
 *		$Revision$
 *		$Date$
 *
 *	Security:
 *		Unclassified
 *
 *	Description:
 *		text
 *
 *	Input Parameters:
 *		type	identifier	description
 *
 *		text
 *
 *	Output Parameters:
 *		type	identifier	description
 *
 *		text
 *
 *	Return Values:
 *		value	description
 *
 *	Side Effects:
 *		text
 *
 *	Limitations and Comments:
 *		text
 *
 *	Development History:
 *		who					when		why
 *		muquit@semcor.com	22-Nov-94	first cut
 */

#include "xhead.h"
#include "xsf.h"

void SelectCB (widget, client_data, call_data)
Widget
	widget;
XtPointer
	client_data;
XtPointer
	call_data;
{

	static XFontStruct
		*font=(XFontStruct *) NULL;

	static XmFontList
		fontlist=(XmFontList) NULL;

	XmStringCharSet
		charset = XmSTRING_DEFAULT_CHARSET;

	XmListCallbackStruct
		*list = (XmListCallbackStruct *) call_data;
	
	char
		*choice;

	int
		n;

	char
		*s;

	XmString
		string;

    unsigned int
        status;

	char
		*teststring = "-Font Preview-";

	n = list->item_position - 1;

	if (n < 0)
		return;

	status=XmStringGetLtoR(list->item, charset, &choice);
    if (status == False)
    {
        Warning("Unable to get choice!",(char *) NULL);
        return;
    }
    if (font != (XFontStruct *) NULL)
    {
        XtVaSetValues(GfontLabW,
            XmNfontList, Gfontlist,
            NULL);

	    XmFontListFree(fontlist);
        XFreeFont(XtDisplay(GfontLabW),font);
        font=(XFontStruct *) NULL;
    }
	font = LoadFont(XtDisplay(GfontLabW), choice);
    if (font == (XFontStruct *) NULL)
    {
        Warning("Unable to load font %s\n",choice);
        return;
    }
	fontlist = XmFontListCreate(font,XmSTRING_DEFAULT_CHARSET);

	XtVaSetValues (GfontLabW,
		XmNfontList, fontlist,
		NULL);

	string = XmStringCreate(teststring,XmFONTLIST_DEFAULT_TAG);
	XtVaSetValues (GfontLabW,
		XmNlabelString, string,
		NULL);

	XmTextFieldSetString(GfontTextW, choice);
	XtFree(choice);	
    XmStringFree(string);
}
